Wikibooks/Wikisource needs means to associate separate pages with books
OpenPublic

Description

Author: mike.lifeguard+bugs

Description:
Wikibooks needs some way of noting what is a book in the database. This bug blocks many Wikibooks-specific feature requests.

Some discussion on this has happened previously:
*http://en.wikibooks.org/w/index.php?title=Wikibooks:Reading_room/Feature_requests&oldid=1230990#How_to_represent_books_in_the_database
*http://lists.wikimedia.org/pipermail/textbook-l/2008-April/001248.html


Version: unspecified
Severity: enhancement
URL: http://en.wikibooks.org/w/index.php?title=Wikibooks:Reading_room/Feature_requests&oldid=1230990#How_to_represent_books_in_the_database

bzimport set Reference to bz15071.
bzimport created this task.Via LegacyAug 7 2008, 5:59 PM
demon added a comment.Via ConduitAug 7 2008, 10:52 PM

I wouldn't say a custom schema. I would think an extension (that will probably add a table or two ;-)) would accomplish it rather well. Keep individual pages as-is, then create a specialpage to "Create a book" and pick pages that go into it. Independent of individual "pages", so each "page" can be updated, just as the wiki is now. With this book metadata stored, you can then begin interfacing with it (AJAX-based book reader, automated table-of-contents, search-in-specific book).

bzimport added a comment.Via ConduitAug 8 2008, 5:30 PM

mike.lifeguard+bugs wrote:

Call it what you will, we need some way of identifying books in the database.

CCing Darklama, as he has thought about this.

siebrand added a comment.Via ConduitAug 10 2008, 11:04 PM

Remove keyword schema-change. There is no patch.

siebrand added a comment.Via ConduitAug 10 2008, 11:07 PM

This is a very specialised feature request(like the dependencies). I seems to me like you should make a comprehensive plan and maybe present it to the Wikimedia Foundation, or a well funded Wikimedia chapter, or some other foundation, for funding. Then develop an extension that gives you what you need to get a proper WikiBooks.

Setting to 'Wikimedia' and 'enhancement'

Platonides added a comment.Via ConduitAug 10 2008, 11:10 PM

There's a http://www.mediawiki.org/wiki/Extension:AllBooks to partly? solve this (linked from the ml msg)

bzimport added a comment.Via ConduitSep 17 2008, 12:47 AM

mike.lifeguard+bugs wrote:

(In reply to comment #5)

There's a http://www.mediawiki.org/wiki/Extension:AllBooks to partly? solve
this (linked from the ml msg)

There are several issues with that:

  1. no caching
  2. relies on a consistently-applied naming scheme
  3. /only counts/lists books - can't be used for anything else we want
  4. probably there are coding issues (such as manually entering the regex in a system message - apparently not a good idea for this limited set of functions, and even worse due to reason 3)
  5. probably stuff I don't know about
Peachey88 added a comment.Via ConduitJul 5 2010, 1:13 AM

Could we use some of them liquid threads code to do the page chaining so it "links" them together, Then all it would need is some sort of syntax to go in the page to tell it what what book it is apart of.

He7d3r added a comment.Via ConduitAug 26 2010, 8:41 PM

Just a side note: the necessity of such a feature was pointed out even before the Wikibooks project was live. Daniel Mayer[1] in Jun 2003:

Textbooks are organized in a very different way than an encyclopedia and they
also have a specific audience. These two things make textbook material
completely incompatible with Wikipedia. Thus a separate project is needed
(and probably a few tweaks to the software to make it easy to have chapters).

So, in this sense, this bug is 7 years old!

[1] http://lists.wikimedia.org/pipermail/wikien-l/2003-June/004788.html

bzimport added a comment.Via ConduitFeb 13 2012, 5:14 PM

ashishmittal.mail wrote:

Hello,

I am looking forward to pursue this issue as my GSoC project.

I have gone through the links and documentation related with this issue. Based on that, I have come up with an initial list of deliverables. The project needs to implement following set of features:

1 Create a book
2 Page addition wizard (also containing search filters for finding particular pages)
3 Import book metadata (my suggestion where user can directly add set of pages from his export list)
4 Export book metadata (export the book details containing all page links to a file which can be saved by user, similar to MetaBooks)
5 Add to a book option for every page
6 Table of contents for a book
7 Read a book
8 Recent changes for each book
9 Create chapters
10 Manage book:

  • Arrange order of pages in a book
  • Protect/watchlist/move/delete all pages

11 List books
12 Search for a book
13 Search in a book
..(any more which would be required)

I have installed the Collection and BookManager extensions and am going through their code base. I would like to ask if it is possible to reuse the existing functionalities from the extensions (ex. Book and chapter creation from Collection, navigation from BookManager, book listing from AllBooks, etc) and extend them to add the rest of features over these functionalities.

Secondly, going through http://en.wikibooks.org/w/index.php?title=Wikibooks:Reading_room/Feature_requests&oldid=1230990#How_to_represent_books_in_the_database suggests multiple ways of implementing the backend. It would be great if someone could guide what would be considered the most suitable way of storing the book metadata. Figuring out these basics and a proper scope would enable me to go more in depth and think from implementation perspective.

Thanks,
Aashish

He7d3r added a comment.Via ConduitFeb 13 2012, 5:44 PM

Hi!

Thank you for your interest on helping our projects! This is really appreciated!

You may want to get in touch with Wikibooks and Wikisource communities through their mailing lists and Village Pumps, asking for any feedback which may help you on this task (such as identifying other requirements not yet mentioned here on bugzilla). So, here are some useful links:

Wikibooks

Wikisource

Maybe it would be better to have a central place where editors from all projects could participate in the discussion (since not everybody has a bugzilla account or is subscribed to the mailing lists). I suggest creating a page such as
https://meta.wikimedia.org/wiki/Books
(better name?) on Meta-wiki. For an example of a page discussing a similar initiative see:
https://meta.wikimedia.org/wiki/Wikidata

Best regards

bzimport added a comment.Via ConduitFeb 13 2012, 7:22 PM

ashishmittal.mail wrote:

Hello,

Thanks for the suggestions.

I have created this page https://meta.wikimedia.org/wiki/Books Will be using this for further development and plans on this project.

Also, will be joining the wikibooks and wikisources mailing list and post an introduction to this project. Will ask for their feedback for the same.

Hope to get this project into action soon.

Thanks,
Aashish

He7d3r added a comment.Via ConduitFeb 18 2012, 11:33 AM
  • Bug 382 has been marked as a duplicate of this bug. ***
He7d3r added a comment.Via ConduitFeb 18 2012, 11:34 AM
  • Bug 1900 has been marked as a duplicate of this bug. ***
Billinghurst added a comment.Via ConduitMar 14 2013, 2:44 AM

Is this now something that should be considered as something that is more related to a push to get data into Wikidata?

raylton.sousa added a comment.Via ConduitMar 14 2013, 12:19 PM

(In reply to comment #14)

Is this now something that should be considered as something that is more
related to a push to get data into Wikidata?

Maybe. But this would only be really useful for the wikibooks if, in the future, wikidata is able to solve all blocked bugs. Mainly bug 15073.

bzimport added a comment.Via ConduitApr 11 2013, 4:24 PM

molly.white5 wrote:

Hello! I'm planning to submit a proposal for Google Summer of Code 2013 (and also Outreach Program for Women) that will address this bug. I plan to improve the BookManager extension to a point where it can be deployed on Wikisource, Wikibooks, etc. This will allow users to combine different pages into a single book, which will then be treated as a single unit. Once this is accomplished, many of the bugs this bug blocks will be able to be addressed.

My full proposal is available at https://www.mediawiki.org/wiki/User:GorillaWarfare/Proposal. I'd really love to get some feedback on this! I'd also like to hear any opinions you might have about its feasibility as a GSoC project, and its relative priority.

raylton.sousa added a comment.Via ConduitApr 11 2013, 5:11 PM

I can help you Molly :)

bzimport added a comment.Via ConduitApr 11 2013, 5:18 PM

molly.white5 wrote:

(In reply to comment #17)

I can help you Molly :)

Wonderful! Did you get the email I sent yesterday?

raylton.sousa added a comment.Via ConduitApr 11 2013, 5:24 PM

Oh dear, I lost it in my inbox, I'm so sorry.
I'll see...

Qgil added a comment.Via ConduitApr 23 2013, 9:15 PM

Just a note to say that Molly White has applied to GSoC with a proposal related to this report. Good luck!

https://www.mediawiki.org/wiki/User:GorillaWarfare/Proposal

bzimport added a comment.Via ConduitJun 10 2013, 4:34 PM

molly.white5 wrote:

Hello! I'd just like to update you all on this project that is related to this bug. I submitted a proposal (https://www.mediawiki.org/wiki/User:GorillaWarfare/Proposal) to Wikimedia for Google Summer of Code, and have been accepted to work on it this summer. I will be working with Raylton P. Sousa and Matthew Walker as my mentors.

I am currently working on creating documentations to plan the project, which you can see at http://meta.wikimedia.org/wiki/Book_management. Any feedback on my work there or on the project in general is more than welcome. I will begin working on the actual code on June 17.

bzimport added a comment.Via ConduitJun 24 2013, 7:17 PM

molly.white5 wrote:

I have created an RfC (http://www.mediawiki.org/wiki/Requests_for_comment/Book_management) to get community feedback on the extension I hope to create. Feedback would be wonderful!

Qgil added a comment.Via ConduitSep 17 2013, 4:17 PM

GSoC "soft pencils down" date was yesterday and all coding must stop on 23 September. Has this project been completed?

raylton.sousa added a comment.Via ConduitSep 17 2013, 6:55 PM

No entirely . Currently we do not have the ability to work with very large books (Bug 52435).

And we have no tool for migration of existing books (Bug 53286).

But some dependences of Bug 15073 have been fixed (Bug 31075, Bug 54231 and Bug 54234)
And we move in the production of a solid tool to manage books in our own bug list:
https://bugzilla.wikimedia.org/buglist.cgi?component=BookManagerv2&product=MediaWiki%20extensions&list_id=234100

Molly! Correct me if I'm wrong.

bzimport added a comment.Via ConduitSep 18 2013, 12:21 AM

molly.white5 wrote:

That's correct, Raylton.

We've been using the bug priority list at https://meta.wikimedia.org/w/index.php?title=Book_management/Bug_priority to organize the bugs on Bugzilla, and it might provide a little more insight into our progress. The bolded bugs are the as-yet unfixed ones that we've decided need to be fixed before we move on to the security review.

bzimport added a comment.Via ConduitOct 1 2013, 9:38 PM

molly.white5 wrote:

I've wrapped up this Summer of Code project with the extension mostly complete, but with a number of open bugs. I've written a blog post on it at http://www.mollywhite.net/blog/?p=104

Qgil added a comment.Via ConduitOct 22 2013, 7:36 PM

If you have open tasks or bugs left, one possibility is to list them at https://www.mediawiki.org/wiki/Google_Code-In and volunteer yourself as mentor.

We have heard from Google and free software projects participating in Code-in that students participating in this programs have done a great work finishing and polishing GSoC projects, many times mentores by the former GSoC student. The key is to be able to split the pending work in little tasks.

More information in the wiki page. If you have questions you can ask there or you can contact me directly.

raylton.sousa added a comment.Via ConduitOct 22 2013, 7:52 PM

Yes.. We have 33 not fixed bugs[1]. I think Bug 52347 and Bug 50679 will be quite simple to Code-in

[1]https://bugzilla.wikimedia.org/buglist.cgi?component=BookManagerv2&resolution=---&list_id=243412

Nemo_bis added a comment.Via ConduitJan 18 2014, 7:54 AM

(In reply to comment #28)

Yes.. We have 33 not fixed bugs[1]. I think Bug 52347 and Bug 50679 will be
quite simple to Code-in

34 now. Raylton or Molly, can either of you make this bug into a request to review and deploy the extension on Wikimedia projects, adding the actual requirements to blockers? It's currently impossible to understand what's the status of the project and how far or close it is to its goals.

raylton.sousa added a comment.Via ConduitFeb 21 2014, 1:56 PM

Bookmanager v2 (in its reading interface) would be ready if you do not have to migrate all books (Wikisource/wikibooks) to the new extension.

I Mean... It works well for:

  • New books (created after the extension already installed) and small (less than 5,000 pages, I think)

It does not work well for:

  • Ancient books (created before the extension to be installed) - Bug 53286
  • Big Books (more than 5,000 pages, I think) - Bug 52435

Of course there are other bugs, but I think these are, currently, the main blockers

Thanks for the comment.

Best regards!

bzimport added a comment.Via ConduitMar 21 2014, 6:18 PM

djdeepalijain811 wrote:

Hello!

I am planning to work on the open issues of Bookmanagerv2 extension as a part of GSoC and OPW 2014, especially the following bugs:

Bug 51239
Bug 53286
Bug 52435

The major focus is on creating a user-friendly, easy-to-use and efficient interface for book editing and reading and migration of existing books to Bookmanagerv2 extension.

Here is my proposal:

https://www.mediawiki.org/wiki/User:Jaindeepali/Proposal#Book_management_in_Wikibooks.2FWikisource

Please provide your opinions and feedback regarding the same. :)

bzimport added a comment.Via ConduitMar 21 2014, 6:19 PM

djdeepalijain811 wrote:

Hello!

I am planning to work on the open issues of Bookmanagerv2 extension as a part of GSoC and OPW 2014, especially the following bugs:

Bug 51239
Bug 53286
Bug 52435

The major focus is on creating a user-friendly, easy-to-use and efficient interface for book editing and reading and migration of existing books to Bookmanagerv2 extension.

Here is my proposal:

https://www.mediawiki.org/wiki/User:Jaindeepali/Proposal

Please provide your opinions and feedback regarding the same. :)

Qgil added a comment.Via ConduitSep 12 2014, 9:30 AM

Deepali's GSoC project was evaluated as PASSED, but it is unclear what is the current status, and the required final blog post seems to be missing.

https://meta.wikimedia.org/wiki/Book_management_2014/Progress

Please wrap up the project properly, documenting any task left open.

He7d3r awarded a token.Via WebNov 24 2014, 12:53 PM
Aklapper added a project: Wikisource.Via WebMar 10 2015, 4:16 PM
Nemo_bis awarded a token.Via WebThu, Apr 9, 8:30 AM

Add Comment

Column Prototype
This is a very early prototype of a persistent column. It is not expected to work yet, and leaving it open will activate other new features which will break things. Press "\" (backslash) on your keyboard to close it now.